import {
    select,
    csv,
    scaleLinear,
    max,
    scaleBand,
    axisLeft,
    axisBottom
} from 'd3'; //imports select and arc module from d3
const svg = select('svg');
const height = +svg.attr('height'); //+ remakes the height of svg from string into a float 
const width = +svg.attr('width');

const render = data => {
    const xValue = d => d.Distance;
    const yValue = d => d.Name;
    const margin = { top: 30, right: 30, bottom: 30, left: 200 }; // since we have a margin we will use inner height and inner width for the scales
    const innerWidth = width - margin.left - margin.right; //calculate inner measuremants
    const innerHeight = height - margin.bottom - margin.top;


    console.log(data.map(xValue)) //shows list of Distances
    console.log(data.map(yValue)) //shows list of countries
    console.log(max(data, xValue))

    const xScale = scaleLinear()
        .domain([0, max(data, xValue)])//domain = data space (data range) to range = screen space (pixels)
        .range([0, innerWidth]); //pixels or viewed space

    console.log(width)
    console.log(innerWidth);
    const yScale = scaleBand()
        .domain(data.map(yValue))
        .range([0, innerHeight])
        .padding(0.2);

    const yAxis = axisLeft(yScale); //makes the axis based on the scale
    const xAxis = axisBottom(xScale);
    //create a group
    const g = svg.append('g')
        .attr('transform', `translate(${margin.left},${margin.top})`);

    g.append('g').call(axisLeft(yScale)); //scale names appended to group element
    g.append('g').call(axisBottom(xScale))
        .attr('transform', `translate(0,${innerHeight})`); //to change from top labels to bottom labels
    g.selectAll('rect').data(data) //data join by passing the data array, append to group instead of svg!
        .enter().append('rect')
        .attr('y', d => yScale(yValue(d)))
        .attr('width', d => xScale(xValue(d))) //scales the width depending on the Distance
        .attr('height', yScale.bandwidth()); //bandwidth = computed width of a single bar

};
csv('data.csv').then(data => {
    data.forEach(d => {
        console.log(d.Distance)
        d.Distance = +d.Distance * 1000; //turns Distance from strings to float OBS! do not have spaces in data!
    console.log(typeof d.Distance)
      console.log(d.Distance)
    });
    render(data)
    console.log(data);
});
